package minischeme

abstract class Opcode(val name: String) {
  override def toString(): String = name
}

abstract class OpcodeRRR(name: String) extends Opcode(name)
case object ADD extends OpcodeRRR("ADD")
case object SUB extends OpcodeRRR("SUB")
case object MUL extends OpcodeRRR("MUL")
case object DIV extends OpcodeRRR("DIV")
case object MOD extends OpcodeRRR("MOD")

case object JLT extends OpcodeRRR("JLT")
case object JLE extends OpcodeRRR("JLE")
case object JEQ extends OpcodeRRR("JEQ")
case object JNE extends OpcodeRRR("JNE")
case object JGE extends OpcodeRRR("JGE")
case object JGT extends OpcodeRRR("JGT")

case object LOAD extends OpcodeRRR("LOAD")
case object STOR extends OpcodeRRR("STOR")

case object ALOC extends Opcode("ALOC")

case object LINT extends Opcode("LINT")

abstract class OpcodeR(name: String) extends Opcode(name)
case object RCHR extends OpcodeR("RCHR")
case object PCHR extends OpcodeR("PCHR")

case object HALT extends Opcode("HALT")
