package minischeme

import scala.collection.immutable.Map

object Primitives {
  val vector = new Symbol("vector", PrimitiveKind)
  val vector_ref = new Symbol("vector-ref", PrimitiveKind)
  val vector_set = new Symbol("vector-set!", PrimitiveKind)
  val add = new Symbol("+", PrimitiveKind)
  val sub = new Symbol("-", PrimitiveKind)
  val mul = new Symbol("*", PrimitiveKind)
  val div = new Symbol("/", PrimitiveKind)
  val mod = new Symbol("%", PrimitiveKind)
  val lt = new Symbol("<", PrimitiveKind)
  val le = new Symbol("<=", PrimitiveKind)
  val eq = new Symbol("=", PrimitiveKind)
  val ge = new Symbol(">=", PrimitiveKind)
  val gt = new Symbol(">", PrimitiveKind)
  val not = new Symbol("not", PrimitiveKind)
  val print_char = new Symbol("print-char", PrimitiveKind)
  val read_char = new Symbol("read-char", PrimitiveKind)
  val halt = new Symbol("halt", PrimitiveKind)

  private val arityTable =
    Map((vector, -1), (vector_ref, 2), (vector_set, 3),
        (add, 2), (sub, 2), (mul, 2), (div, 2), (mod, 2),
        (lt, 2), (le, 2), (eq, 2), (ge, 2), (gt, 2), (not, 1),
        (print_char, 1), (read_char, 1),
        (halt, 0));

  val symbols: List[Symbol] =
    arityTable.keys.toList

  def arity(sym: Symbol): Int =
    arityTable(sym)
}
