package minischeme

class Register(index: Int) extends Representable {
  override def representation: String = "R" + index
}

object Registers extends (Int => Register) {
  private val existing: List[Register] =
    for (r <- List.range(0, 32)) yield
      new Register(r)

  val R0 = existing(0)
  val LK = existing(29)
  val FP = existing(30)
  val GP = existing(31)

  val allocatable: List[Register] =
    existing -- List(R0, LK, FP, GP)

  def apply(i: Int): Register = existing(i)
}


