package minischeme

import scala.util.parsing.syntax.Tokens

trait SExpTokens extends Tokens {
  abstract class SExpToken extends Token {
    override def toString: String = chars
  }

  case object LPar extends SExpToken { def chars = "(" }
  case object RPar extends SExpToken { def chars = ")" }
  case object Define extends SExpToken { def chars = "define" }
  case object Lambda extends SExpToken { def chars = "lambda" }
  case object Let extends SExpToken { def chars = "let" }
  case object Begin extends SExpToken { def chars = "begin" }
  case object If extends SExpToken { def chars = "if" }
  case object And extends SExpToken { def chars = "and" }
  case object Or extends SExpToken { def chars = "or" }
  case class Ident(val chars: String) extends SExpToken
  case class Num(n: Int) extends SExpToken { def chars = String.valueOf(n) }
  case class Str(val chars: String) extends SExpToken
  case class Chr(c: Char) extends SExpToken { def chars = String.valueOf(c) }
}
